﻿Type=Class
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Event: StateChanged (State As Int)
Sub Class_Globals
	Private EventName As String
	Private CallBack As Object
	Private bar As SeekBar
	Private timer1 As Timer
	Private lastUpdate As Long
	Private const NUMBER_OF_STATES As Int = 3
	Private lastState As Int = -1
End Sub



Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	bar.Initialize("bar")
	timer1.Initialize("timer1", 30)
End Sub

'Returns a view object that holds the list.
Public Sub AsView As View
	Return bar
End Sub

Public Sub DesignerCreateView(base As Panel, lbl As Label, props As Map)
	Dim parent As Panel
	Dim r As Reflector
	r.Target = base
	parent = r.RunMethod("getParent")
	base.RemoveView 'remove the base panel
	parent.AddView(bar, base.Left, base.Top, base.Width, base.Height)
End Sub

Private Sub bar_ValueChanged (Value As Int, UserChanged As Boolean)
	If UserChanged = False Then Return
	timer1.Enabled = True
	lastUpdate = DateTime.Now
End Sub

Private Sub Timer1_Tick
	If DateTime.Now - lastUpdate > 50 Then
		timer1.Enabled = False
		Dim state As Int = Round(bar.Value / 100 * (NUMBER_OF_STATES -1))
		bar.Value = 100 * state / (NUMBER_OF_STATES -1)
		If lastState <> state Then
			lastState = state
			CallSub2(CallBack, EventName & "_statechanged", state)
		End If
	End If
End Sub

